/*
								+---------------------------------+
								|                                 |
								|      ***   The Life   ***       |
								|                                 |
								|    Copyright  L. Polok  2002   |
								|                                 |
								|             Life.h              |
								|                                 |
								+---------------------------------+
*/

// ----- Konstanty ----------------------------------------

#define CELL_NONE 0x00
#define CELL_DEAD 0x01
#define CELL_LIVE 0x02
// stavy bunek


#define x_Size      64
#define y_Size      64
#define z_Size      64
#define Max_Index   0x40000
// velikost matice

#define x_Mask      0x0003f
#define y_Mask      0x00fc0
#define z_Mask      0x3f000
#define x_Shift     0
#define y_Shift     6
#define z_Shift     12
// konstanty pro optimalizaci


/*
#define x_Size      16
#define y_Size      16
#define z_Size      16
#define Max_Index   0x1000
// velikost matice

#define x_Mask      0x00f
#define y_Mask      0x0f0
#define z_Mask      0xf00
#define x_Shift     0
#define y_Shift     4
#define z_Shift     8
// konstanty pro optimalizaci
*/

/*
#define x_Size      64
#define y_Size      64
#define z_Size      1
#define Max_Index   0x1000
// velikost matice

#define x_Mask      0x0003f
#define y_Mask      0x00fc0
#define z_Mask      0x01000
#define x_Shift     0
#define y_Shift     6
#define z_Shift     12
// konstanty pro optimalizaci
*/


// ----- Datove typy --------------------------------------

typedef char Cell;
// jedna bunka

typedef Cell Life_Matrix[x_Size][y_Size][z_Size];
// matice, kde se life hraje
// (velikost = 256 kB pri Matrix_Size = 64)



// ----- Funkce -------------------------------------------

void Init_Life();
// nahraje konstanty

void Proceed_Life(Life_Matrix *p_m);
// udela zmeny v poli p_m

Life_Matrix *Create_LMatrix(char *ini_file);
// nahraje matrici ze souboru.
// ten obsahuje :
//  - na zacatku cislo, znacici pocet zivych bunek
//  - potom trojice cisel, szmbolizujici jejich souradnice
//
// ostatni bunky se nastavi na mrtfe.